/* Copyright (C) 2010, Pascal Giorgi
 *
 * copied from the GF2X library (http://gforge.inria.fr/projects/gf2x/) under GPL licence
 *
 * ========LICENCE========
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *   along with this program.  If not, see <http://www.gnu.org/licenses/>.
 * ========LICENCE========
 */

#ifndef TIMING_H_
#define TIMING_H_

#ifdef __cplusplus
extern "C" {
#endif

#include <stdint.h>

#include <sys/time.h>
#include <sys/resource.h>
#define HAS_microseconds
 uint64_t microseconds()
{
	struct rusage res[1];
	getrusage(RUSAGE_SELF,res);
	uint64_t r;
	r  = (uint64_t) res->ru_utime.tv_sec;
	r *= (uint64_t) 1000000UL;
	r += (uint64_t) res->ru_utime.tv_usec;
	return r;
}

#if defined (__i386__) || defined(__x86_64__)
#define	HAS_cputicks
static inline uint64_t cputicks()
{
	uint64_t r;
        __asm__ __volatile__(
                ".align 64\n\t"
                "xorl %%eax,%%eax\n\t"
                "cpuid\n\t"
                "rdtsc\n\t"
                "movl %%eax,(%0)\n\t"
                "movl %%edx,4(%0)\n\t"
                "xorl %%eax,%%eax\n\t"
                "cpuid\n\t"
                : /* no output */
                : "S"(&r)
                : "eax", "ebx", "ecx", "edx", "memory");
	return r;
}
#endif

#define MLSPSEC 1000
#define MCSPSEC 1000000 //Microseconds per second
#define NASPSEC 1000000000 //Nanoseconds per second


//Timer linux
double get_time()
{
  struct rusage  time;  // to getrusage (sys+user times)
  getrusage (RUSAGE_SELF, &time);
   
  double result=(double)time.ru_utime.tv_sec * MCSPSEC;
  result+=(double)time.ru_utime.tv_usec;
  
  return result;
}

#ifdef __cplusplus
}
#endif

#endif	/* TIMING_H_ */
